Loading...
Searching...
No Matches
casacore::ImageExpr< T > Class Template Reference
images package (libcasa_images) » Images_module

More...

`#include <ImageExpr.h>`

## Public Member Functions

| ImageExpr ()
| The default constructor.
| ImageExpr (const LatticeExpr< T > &latticeExpr, const String &expr, const String &fileName=String())
| Construct an ImageExpr from a LatticeExpr.
| ImageExpr (const LatticeExpr< T > &latticeExpr, const String &expr, const String &fileName, const JsonKVMap &)
| ImageExpr (const LatticeExpr< T > &latticeExpr, const String &expr, const String &fileName, const LELImageCoord &imCoord)
| Same as previous constructor, but the coordinates are taken from the given LELImageCoord object.
| ImageExpr (const ImageExpr< T > &other)
| Copy constructor (reference semantics).
| ~ImageExpr ()
| Destructor does nothing.
ImageExpr< T > & | operator= (const ImageExpr< T > &other)
| Assignment (reference semantics).
virtual ImageInterface< T > * | cloneII () const
| Make a copy of the object (reference semantics).
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
void | setFileName (const String &name)
| Set the file name.
virtual Bool | setMiscInfo (const RecordInterface &newInfo)
| Replace the miscinfo in the ImageExpr, which writes the image.expr file.
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | isMasked () const
| Has the object really a mask?
virtual const LatticeRegion * | getRegionPtr () const
| Get the region used.
virtual IPosition | shape () const
| return the shape of the ImageExpr
virtual void | resize (const TiledShape &newShape)
| Function which changes the shape of the ImageExpr.
virtual Bool | doGetMaskSlice (Array< Bool > &buffer, const Slicer &section)
| Do the actual get of the mask data.
virtual Bool | doGetSlice (Array< T > &buffer, const Slicer &theSlice)
| Do the actual get of the data.
virtual void | doPutSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| putSlice is not possible on an expression, so it throws an exception.
virtual String | name (Bool stripPath=False) const
| If the object is persistent, the file name is given.
virtual Bool | ok () const
| Check class invariants.
virtual LatticeIterInterface< T > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| These are the implementations of the LatticeIterator letters.
virtual Bool | isWritable () const
| Returns False, as the ImageExpr is not writable.
virtual Bool | isPersistent () const
| Is the lattice persistent and can it be loaded by other processes as well?
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| Help the user pick a cursor for most efficient access if they only want pixel values and don't care about the order or dimension of the cursor.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| Handle the (un)locking and syncing.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual void | tempClose ()
| Temporarily close the lattice.
virtual void | reopen ()
| Explicitly reopen the temporarily closed lattice.
const LatticeExpr< T > & | expression () const
| Get the lattice expression.
Public Member Functions inherited from casacore::ImageInterface< T >
| ImageInterface ()
| ImageInterface (const RegionHandler &regionHandler)
| Construct for a specific region handler object.
| ImageInterface (const ImageInterface &other)
| Copy constructor (copy semantics).
virtual | ~ImageInterface ()
virtual MaskedLattice< T > * | cloneML () const
| Make a copy of the derived object (reference semantics).
virtual Bool | setUnits (const Unit &newUnits)
| Function which get and set the units associated with the image pixels (i.e.
virtual const Unit & | units () const
virtual Bool | setCoordinateInfo (const CoordinateSystem &coords)
| Functions to set or replace the coordinate information in the Image Returns False on failure, e.g.
const CoordinateSystem & | coordinates () const
virtual LELCoordinates | lelCoordinates () const
| Function to get a LELCoordinate object containing the coordinates.
LoggerHolder & | logger ()
| Get access to the LoggerHolder.
const LoggerHolder & | logger () const
LogIO & | logSink ()
| Allow messages to be logged to this ImageInterface.
const LogIO & | logSink () const
void | appendLog (const LoggerHolder &other)
| Add the messages from the other image logger to this one.
const TableRecord & | miscInfo () const
| Often we have miscellaneous information we want to attach to an image.
const ImageInfo & | imageInfo () const
| The ImageInfo object contains some miscellaneous information about the image which unlike that stored in MiscInfo, has a standard list of things, such as the restoring beam.
ImageInfo & | rwImageInfo ()
| Get non-const access to the ImageInfo.
virtual Bool | setImageInfo (const ImageInfo &info)
virtual ImageAttrHandler & | attrHandler (Bool createHandler=False)
| Get access to the attribute handler.
ImageAttrHandler & | roAttrHandler () const
Bool | canDefineRegion () const
| Can the image handle region definition?
virtual ImageRegion | makeMask (const String &name, Bool defineAsRegion=True, Bool setAsDefaultMask=True, Bool initialize=False, Bool value=True)
| Make a mask which is suitable for the type of image.
virtual void | defineRegion (const String &name, const ImageRegion &region, RegionHandler::GroupType, Bool overwrite=False)
| Define a region/mask belonging to the image.
virtual Bool | hasRegion (const String &regionName, RegionHandler::GroupType=RegionHandler::Any) const
| Does the image have a region with the given name?
virtual ImageRegion * | getImageRegionPtr (const String &name, RegionHandler::GroupType=RegionHandler::Any, Bool throwIfUnknown=True) const
| Get a region/mask belonging to the image from the given group (which can be Any).
virtual void | renameRegion (const String &newName, const String &oldName, RegionHandler::GroupType=RegionHandler::Any, Bool overwrite=False)
| Rename a region.
virtual void | removeRegion (const String &name, RegionHandler::GroupType=RegionHandler::Any, Bool throwIfUnknown=True)
| Remove a region/mask belonging to the image from the given group (which can be Any).
virtual Vector< String > | regionNames (RegionHandler::GroupType=RegionHandler::Any) const
| Get the names of all regions/masks.
virtual void | useMask (MaskSpecifier=MaskSpecifier())
| Use the mask as specified.
virtual void | setDefaultMask (const String &regionName)
| Set the default pixelmask to the mask with the given name (which has to exist in the "masks" group).
virtual String | getDefaultMask () const
| Get the name of the default pixelmask.
ImageRegion | getRegion (const String &regionName, RegionHandler::GroupType=RegionHandler::Any) const
| Get a region belonging to the image.
String | makeUniqueRegionName (const String &rootName, uInt startNumber=1) const
| Make a unique region name from the given root name, thus make it such that the name is not already in use for a region or mask.
Bool | toRecord (String &error, RecordInterface &outRec)
| Save and restore an ImageInterface object to or from a state Record.
Bool | fromRecord (String &error, const RecordInterface &inRec)
Public Member Functions inherited from casacore::MaskedLattice< T >
| MaskedLattice ()
| Default constructor.
| MaskedLattice (const MaskedLattice< T > &)
| Copy constructor.
virtual | ~MaskedLattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual Lattice< T > * | clone () const
| Make a copy of the derived object (reference semantics).
virtual Bool | hasPixelMask () const
| Does the lattice have a pixelmask?
virtual const Lattice< Bool > & | pixelMask () const
| Get access to the pixelmask.
virtual Lattice< Bool > & | pixelMask ()
const LatticeRegion & | region () const
| Get the region used.
Bool | getMask (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Get the mask or a slice from the mask.
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | getMask (Array< Bool > &buffer, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< Bool > | getMask (Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Public Member Functions inherited from casacore::Lattice< T >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
T | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual T | getAt (const IPosition &where) const
virtual void | putAt (const T &value, const IPosition &where)
| Put the value of a single element.
Bool | get (COWPtr< Array< T > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< T > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | get (Array< T > &buffer, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< T > | get (Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where)
void | put (const Array< T > &sourceBuffer)
virtual void | set (const T &value)
| Set all elements in the Lattice to the given value.
virtual void | apply (T(*function)(T))
| Replace every element, x, of the Lattice with the result of f(x).
virtual void | apply (T(*function)(const T &))
virtual void | apply (const Functional< T, T > &function)
void | operator+= (const Lattice< T > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< T > &other)
void | operator*= (const Lattice< T > &other)
void | operator/= (const Lattice< T > &other)
virtual void | copyData (const Lattice< T > &from)
| Copy the data from the given lattice to this one.
virtual void | copyDataTo (Lattice< T > &to) const
| Copy the data from this lattice to the given lattice.
virtual uInt | advisedMaxPixels () const
| This function returns the advised maximum number of pixels to include in the cursor of an iterator.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual Bool | isPaged () const
| Is the lattice paged to disk?
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual void | flush ()
| Flush the data (but do not unlock).
virtual uInt | ndim () const
| Return the number of axes in this Lattice.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual uInt | maximumCacheSize () const
| Maximum cache size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be big enough for the indicated number of tiles.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.

## Private Member Functions

void | init (const LatticeExpr< T > &latticeExpr, const String &expr, const String &fileName, const JsonKVMap &)

## Private Attributes

LatticeExpr< T > | latticeExpr_p
Unit | unit_p
String | exprString_p
String | fileName_p

## Additional Inherited Members

Protected Member Functions inherited from casacore::ImageInterface< T >
ImageInterface & | operator= (const ImageInterface &other)
| Assignment (copy semantics) is only useful for derived classes.
Bool | restoreImageInfo (const RecordInterface &rec)
| Restore the image info from the record.
void | setLogMember (const LoggerHolder &logger)
| Set the image logger variable.
void | setImageInfoMember (const ImageInfo &imageInfo)
| Set the image info variable.
void | setCoordsMember (const CoordinateSystem &coords)
| Set the coordinate system variable.
void | setUnitMember (const Unit &unit)
| Set the unit variable.
void | setMiscInfoMember (const RecordInterface &rec)
| Set the miscinfo variable.
RegionHandler * | getRegionHandler ()
| Get access to the region handler.
Protected Member Functions inherited from casacore::MaskedLattice< T >
MaskedLattice< T > & | operator= (const MaskedLattice< T > &)
| Assignment can only be used by derived classes.
Protected Member Functions inherited from casacore::Lattice< T >
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< T > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
virtual void | handleMathTo (Lattice< T > &to, int oper) const
| Lattice (const Lattice< T > &)
| Copy constructor and assignment can only be used by derived classes.
Lattice< T > & | operator= (const Lattice< T > &)
void | handleMathTo (Lattice< Bool > &, int) const
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Detailed Description

template<class T>
class casacore::ImageExpr< T >

Hold mathematical expressions involving ImageInterface objects

### Intended use:

Public interface

### Review Status

Test programs:
  tImageExpr

### Prerequisite

- LatticeExpr
- ImageInterface

### Etymology

This class holds a LatticeExpr object but inherits from ImageInterface hence ImageExpr

### Synopsis

An ImageExpr object holds a LatticeExpr object which can be used to evaluate mathematical expressions involving Lattices. ImageExpr exists so that direct manipulation of LatticeExpr objects by methods expecting an ImageInterface, rather than a Lattice can occur.

The ImageExpr object is constructed from a LatticeExpr object, but only if the latter has true Coordinates associated with it. The ImageExpr object is not writable, so the ImageExpr object functions like a read only ImageInterface.

### Example

PagedImage<Float> a("imageB"); // Open PagedImages
PagedImage<Float> b("imageB");
LatticeExprNode node(a+b); // Create ImageExpr
LatticeExpr<Float> lExpr(node);
ImageExpr<Float> iExpr(lExpr);
LogOrigin or("imageImpl", "main()", WHERE); // Create statistics object
LogIO logger(or);
ImageStatistics<Float> stats(iExpr, logger);
Bool ok = stats.display(); // Display statistics
WHERE
#define WHERE
Definition LogOrigin.h:212
casacore::ImageExpr::ImageExpr
ImageExpr()
The default constructor.
casacore::ImageExpr::ok
virtual Bool ok() const
Check class invariants.
casacore::ImageInterface::logger
LoggerHolder & logger()
Get access to the LoggerHolder.
Definition ImageInterface.h:202
casacore::ImageStatistics
Definition ImageStatistics.h:98
casacore::LatticeExprNode
Definition LatticeExprNode.h:439
casacore::LatticeExpr
Definition LatticeExpr.h:141
casacore::LogIO
Definition LogIO.h:165
casacore::LogOrigin
Definition LogOrigin.h:92
casacore::PagedImage
Definition PagedImage.h:134
casacore::Bool
bool Bool
Define the standard types used by Casacore.
Definition aipstype.h:40

The ImageExpr object is evaluated during the call to stats.dislay(). Previously, the expression tree has been constructed, but not evaluated.

### Motivation

This enables one to evaluate expressions but not to have to write them out to an output image.

Definition at line 109 of file ImageExpr.h.

## Constructor & Destructor Documentation

## ImageExpr() [1/5]

template<class T>

casacore::ImageExpr< T >::ImageExpr | ( |  | ) |

The default constructor.

Referenced by ImageExpr(), and operator=().

## ImageExpr() [2/5]

template<class T>

casacore::ImageExpr< T >::ImageExpr | ( | const LatticeExpr< T > & | latticeExpr,
|  | const String & | expr,
|  | const String & | fileName = String() )

Construct an ImageExpr from a LatticeExpr.

The expr given should be the original expression string. The fileName argument is meant for ImageOpener. The coordinates are taken from the expression, usually the first image. An exception is thrown if the expression has no coordinates.

## ImageExpr() [3/5]

template<class T>

casacore::ImageExpr< T >::ImageExpr | ( | const LatticeExpr< T > & | latticeExpr,
|  | const String & | expr,
|  | const String & | fileName,
|  | const JsonKVMap & | )

## ImageExpr() [4/5]

template<class T>

casacore::ImageExpr< T >::ImageExpr | ( | const LatticeExpr< T > & | latticeExpr,
|  | const String & | expr,
|  | const String & | fileName,
|  | const LELImageCoord & | imCoord )

Same as previous constructor, but the coordinates are taken from the given LELImageCoord object.

## ImageExpr() [5/5]

template<class T>

casacore::ImageExpr< T >::ImageExpr | ( | const ImageExpr< T > & | other | ) |

Copy constructor (reference semantics).

References ImageExpr().

## ~ImageExpr()

template<class T>

casacore::ImageExpr< T >::~ImageExpr | ( |  | ) |

Destructor does nothing.

## Member Function Documentation

## cloneII()

template<class T>

virtual ImageInterface< T > * casacore::ImageExpr< T >::cloneII | ( |  | ) | const

virtual

Make a copy of the object (reference semantics).

Implements casacore::ImageInterface< T >.

References casacore::ImageInterface< T >::ImageInterface().

## doGetMaskSlice()

template<class T>

virtual Bool casacore::ImageExpr< T >::doGetMaskSlice | ( | Array< Bool > & | buffer,
|  | const Slicer & | section )

virtual

Do the actual get of the mask data.

The return value is always False, thus the buffer does not reference another array.

Reimplemented from casacore::MaskedLattice< T >.

## doGetSlice()

template<class T>

virtual Bool casacore::ImageExpr< T >::doGetSlice | ( | Array< T > & | buffer,
|  | const Slicer & | theSlice )

virtual

Do the actual get of the data.

Implements casacore::Lattice< T >.

## doNiceCursorShape()

template<class T>

virtual IPosition casacore::ImageExpr< T >::doNiceCursorShape | ( | uInt | maxPixels | ) | const

virtual

Help the user pick a cursor for most efficient access if they only want pixel values and don't care about the order or dimension of the cursor.

Reimplemented from casacore::LatticeBase.

## doPutSlice()

template<class T>

virtual void casacore::ImageExpr< T >::doPutSlice | ( | const Array< T > & | sourceBuffer,
|  | const IPosition & | where,
|  | const IPosition & | stride )

virtual

putSlice is not possible on an expression, so it throws an exception.

Implements casacore::Lattice< T >.

## expression()

template<class T>

const LatticeExpr< T > & casacore::ImageExpr< T >::expression | ( |  | ) | const

inline

Get the lattice expression.

Definition at line 219 of file ImageExpr.h.

References latticeExpr_p.

## getRegionPtr()

template<class T>

virtual const LatticeRegion * casacore::ImageExpr< T >::getRegionPtr | ( |  | ) | const

virtual

Get the region used.

Implements casacore::MaskedLattice< T >.

## hasLock()

template<class T>

virtual Bool casacore::ImageExpr< T >::hasLock | ( | FileLocker::LockType |  | ) | const

virtual

Reimplemented from casacore::LatticeBase.

## imageType()

template<class T>

virtual String casacore::ImageExpr< T >::imageType | ( |  | ) | const

virtual

Get the image type (returns name of derived class).

Implements casacore::ImageInterface< T >.

## init()

template<class T>

void casacore::ImageExpr< T >::init | ( | const LatticeExpr< T > & | latticeExpr,
|  | const String & | expr,
|  | const String & | fileName,
|  | const JsonKVMap & | )

private

## isMasked()

template<class T>

virtual Bool casacore::ImageExpr< T >::isMasked | ( |  | ) | const

virtual

Has the object really a mask?

Reimplemented from casacore::MaskedLattice< T >.

## isPersistent()

template<class T>

virtual Bool casacore::ImageExpr< T >::isPersistent | ( |  | ) | const

virtual

Is the lattice persistent and can it be loaded by other processes as well?

Reimplemented from casacore::LatticeBase.

## isWritable()

template<class T>

virtual Bool casacore::ImageExpr< T >::isWritable | ( |  | ) | const

virtual

Returns False, as the ImageExpr is not writable.

Reimplemented from casacore::LatticeBase.

## lock()

template<class T>

virtual Bool casacore::ImageExpr< T >::lock | ( | FileLocker::LockType | ,
|  | uInt | nattempts )

virtual

Handle the (un)locking and syncing.

Reimplemented from casacore::LatticeBase.

## makeIter()

template<class T>

virtual LatticeIterInterface< T > * casacore::ImageExpr< T >::makeIter | ( | const LatticeNavigator & | navigator,
|  | Bool | useRef ) const

virtual

These are the implementations of the LatticeIterator letters.

Note: not for public use

Reimplemented from casacore::Lattice< T >.

## name()

template<class T>

virtual String casacore::ImageExpr< T >::name | ( | Bool | stripPath = False | ) | const

virtual

If the object is persistent, the file name is given.

Otherwise it returns the expression string given in the constructor.

Implements casacore::ImageInterface< T >.

References casacore::False.

Referenced by setFileName().

## ok()

template<class T>

virtual Bool casacore::ImageExpr< T >::ok | ( |  | ) | const

virtual

Check class invariants.

Implements casacore::ImageInterface< T >.

## operator=()

template<class T>

ImageExpr< T > & casacore::ImageExpr< T >::operator= | ( | const ImageExpr< T > & | other | ) |

Assignment (reference semantics).

References ImageExpr().

## reopen()

template<class T>

virtual void casacore::ImageExpr< T >::reopen | ( |  | ) |

virtual

Explicitly reopen the temporarily closed lattice.

By default the function does not do anything at all.

Reimplemented from casacore::LatticeBase.

## resize()

template<class T>

virtual void casacore::ImageExpr< T >::resize | ( | const TiledShape & | newShape | ) |

virtual

Function which changes the shape of the ImageExpr.

Throws an exception as ImageExpr is not writable.

Implements casacore::ImageInterface< T >.

## resync()

template<class T>

virtual void casacore::ImageExpr< T >::resync | ( |  | ) |

virtual

Resynchronize the Lattice object with the lattice file.

This function is only useful if no read-locking is used, ie. if the table lock option is UserNoReadLocking or AutoNoReadLocking. In that cases the table system does not acquire a read-lock, thus does not synchronize itself automatically.
By default the function does not do anything at all.

Reimplemented from casacore::LatticeBase.

## save()

template<class T>

virtual void casacore::ImageExpr< T >::save | ( | const String & | fileName | ) | const

virtual

Save the image in an AipsIO file with the given name.

It can be opened by ImageOpener::openExpr.

Reimplemented from casacore::LatticeBase.

## setFileName()

template<class T>

void casacore::ImageExpr< T >::setFileName | ( | const String & | name | ) |

inline

Set the file name.

Definition at line 148 of file ImageExpr.h.

References fileName_p, and name().

## setMiscInfo()

template<class T>

virtual Bool casacore::ImageExpr< T >::setMiscInfo | ( | const RecordInterface & | newInfo | ) |

virtual

Replace the miscinfo in the ImageExpr, which writes the image.expr file.

It can fail if, e.g., the directory to write to is not writable.

Reimplemented from casacore::ImageInterface< T >.

References casacore::RecordInterface().

## shape()

template<class T>

virtual IPosition casacore::ImageExpr< T >::shape | ( |  | ) | const

virtual

return the shape of the ImageExpr

Implements casacore::LatticeBase.

## tempClose()

template<class T>

virtual void casacore::ImageExpr< T >::tempClose | ( |  | ) |

virtual

Temporarily close the lattice.

It will be reopened automatically on the next access.
By default the function does not do anything at all.

Reimplemented from casacore::LatticeBase.

## unlock()

template<class T>

virtual void casacore::ImageExpr< T >::unlock | ( |  | ) |

virtual

Reimplemented from casacore::LatticeBase.

## Member Data Documentation

## exprString_p

template<class T>

String casacore::ImageExpr< T >::exprString_p

private

Definition at line 230 of file ImageExpr.h.

## fileName_p

template<class T>

String casacore::ImageExpr< T >::fileName_p

mutable private

Definition at line 231 of file ImageExpr.h.

Referenced by setFileName().

## latticeExpr_p

template<class T>

LatticeExpr<T> casacore::ImageExpr< T >::latticeExpr_p

private

Definition at line 228 of file ImageExpr.h.

Referenced by expression().

## unit_p

template<class T>

Unit casacore::ImageExpr< T >::unit_p

private

Definition at line 229 of file ImageExpr.h.

The documentation for this class was generated from the following file:

- images/Images/ImageExpr.h